/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <Database.h>
#include <Directory.h>
#include <Set.h>
#include <libc.h>
#include <stdio.h>
#include "oo7.h"
#include "globals.h"
#include "VarParams.h"
#include "GenParams.h"

#define DUMMYSIZE	1000

////////////////////////////////////////////////////////////////////////////
//
// Dummy Constructor
//
////////////////////////////////////////////////////////////////////////////

Dummy::Dummy()
{
    // initialize direct type --- required by Ontos.
    initDirectType((Type*)OC_lookup("Dummy"));

    // allocate the text array.
    text = new char[DUMMYSIZE];

}

// Additional constructor required by Ontos.
Dummy::Dummy(APL *theAPL) : Object(theAPL) {}

// required by Ontos
Type* Dummy::getDirectType() {
    return (Type*) OC_lookup("Dummy");
}


// destructor
Dummy::~Dummy()
{
    delete text;
}


// create cnt dummy objects in a collection
void createDummy (int cnt)
{
    int i;
    Dummy* dummy;

    // create cnt dummy objects 
    for (i=0;i<cnt;i++) 
    {
        // create a dummy
	dummy = new (oo7Group,(Type*)OC_lookup("Dummy"))  Dummy();
        // insert it into the set of dummy objects
	AllDummyObjects->Insert(dummy);
        // put the new dummy into the database
        dummy->putObject();
/*
	if ((i%1000) == 0) 
	{
		printf("created %d dummy objects\n",i);
		OC_transactionCommit(OC_cleanCache);
	    	OC_transactionStart();
		AllDummyObjects = (Set *) OC_lookup("Dummy");
		oo7Group = (Group *) OC_lookup("oo7Group");
	}
*/
    }

    // put the set
    AllDummyObjects->putObject();
}

// scan DummySet collection retrieving all the dummy objects
void Purge()
{
     SetIterator*    dummyItr;
     Dummy* dummy;
     char c;
     int cnt=0;
	
     // establish new iterator.
     dummyItr = new SetIterator(AllDummyObjects);
     while (dummyItr->moreData())
     {
        dummy = (Dummy*)(Entity*)(*dummyItr)();
        if (dummy == NULL) {
            printf("Yikes, dummy was null.\n");
        }
	cnt++;
        c = dummy->text[0]; // extract the first character
     }
     printf("number of dummy objects examined = %d\n",cnt);
}



/*  $Version: Dummy.C 1.2 93/02/22 09:46:39 Exp $ */

