/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <stdio.h>
#include <Dictionary.h>
#include <Group.h>

#include "oo7.h"
#include "globals.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #7 --- iterate through all atomic parts.  Checks scan
// speed.  Some duplication with other queries, especially in
// systems that lack indices and force the other queries to be
// done by iterating through sets.
//
//////////////////////////////////////////////////////////////////


extern int	debugMode;



//////////////////////////////////////////////////////////////////
//
// Routine to do Query #7
//
//////////////////////////////////////////////////////////////////


int query7()
{
#ifdef ORIG
    DictionaryIterator* partItr; // ONTOS iterator for traversing 
                                 // AllPartsById collection
    AtomicPart* ap;
    int count = 0;

    partItr = new DictionaryIterator(AllPartsById);
    while (partItr->moreData()) {
        ap = (AtomicPart*)(Entity*)(*partItr)();
        if (debugMode) {
            printf("    In Query7, partId = %d:\n", ap->id);
        }

	ap->DoNothing();
        count++;
    }
    delete partItr;
#else
    GroupInstanceIterator* partItr; // ONTOS iterator for traversing 
                                 // AllPartsById collection
    AtomicPart* ap;
    int count = 0;

    partItr = oo7Group->getInstances (APType);
    while (partItr->moreData()) {
        ap = (AtomicPart*)(*partItr)();
        if (debugMode) {
            printf("    In Query7, partId = %d:\n", ap->id);
        }

	ap->DoNothing();
        count++;
    }
    delete partItr;
#endif
    return count;
}

/*  $Version: Query7.C 1.1 93/02/19 16:07:31 Exp $ */

