/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

#include <libc.h>
#include <stdio.h>

#include "oo7.h"
#include <QueryIterator.h>
#include <Directory.h>
#include <ArgumentList.h>
#include "globals.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"


//////////////////////////////////////////////////////////////////
//
// Query #8 --- value join between Documents and AtomicParts
// on Document.id and AtomicPart.docId.  This is a key - foreign
// key join.
//
// The main drawback is that we have no semantics whatsoever for
// this query.
//
// This is the SQL version.
//
//////////////////////////////////////////////////////////////////

extern int	debugMode;
extern void JoinDoNothing(int x, int y);


//////////////////////////////////////////////////////////////////
//
// Routine to do Query #8SQL
//
//////////////////////////////////////////////////////////////////


int query8()
{
    QueryIterator *qItr;
    ArgumentList *argL;  // pointer to rows of query result.
    AtomicPart *atomH;
    Document *docH;
    char theQuery[256];
    int count = 0;
    int pid, did;

    // create the iterator once to avoid overhead.
    qItr = new QueryIterator((char *) 0);

    sprintf(theQuery, 
            "select P.id, D.id from AllPartsById P, AllDocumentsByTitle D where P.id = D.id;");

printf("Running query \"%s\"\n", theQuery);

    qItr->Reset(theQuery);

printf("Running query \"%s\"\n", theQuery);
    if (qItr->SQLCode() == QueryFailed) {
        fprintf(stderr, "Query %s failed.\n", theQuery);
        OC_transactionAbort();
        exit(1);
    } else {
        while (qItr->moreData()) {
            count++;
printf("\ncount = %d\n", count);
            // get next match and advance iterator.
            argL = (ArgumentList*)(Entity*)(*qItr)();  
//            atomH = (AtomicPart*)(Entity*) (*argL)[0];
//            docH = (Document*)(Entity*) (*argL)[1];
            pid = (int) (*argL)[0];
            did = (int) (*argL)[1];
            if (debugMode) {
                printf("    In Query8, partId = %d, docId = \n", 
                       pid, did);
            }
            // process part by calling the null procedure
            JoinDoNothing(pid, did);
        }
    }
    delete qItr;
    return count;
}

/*  $Version: Query8SQL.C 1.1 93/02/19 16:07:34 Exp $ */

