/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/

// structure for keeping track of a list of base assemblies
// that reference a composite part as either a shared or private member

class BAListElem {
public:
    int  baId;   // base assembly id
    BAListElem*	next;
};

class BAIdList {
private:
    BAListElem* listPtr;
    BAListElem* current;

public:
    BAIdList() {listPtr = NULL; current=NULL;};
    void insert(int baId); // insert a new BA identifier in list
    BaseAssembly* next(); // scan list returning all elements
    void  initScan(); // scan list returning all elements
    int	  save(int size, char* fileName); // save into a file
    int	  restore(int size, char* fileName); // restore from a file
};

